/*
 * $Id: BrowserApp.java,v 1.2 1998/10/22 23:03:16 begolej Exp $
 *
 * Copyright (c) 1998 James Begole,  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.
 * James Begole SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS
 * SOFTWARE OR ITS DERIVATIVES.
 */

import java.awt.*;
import java.awt.event.*;

/**
 * A simple application wrapper to run the Browser
 *
 * @version     $Revision: 1.2 $
 * @author  James "Bo" Begole
 */

public class BrowserApp {
  public static void main(String [] args) {
    Frame frame = new Frame();
    frame.setLayout(new BorderLayout());
    frame.add("Center", new Browser());

    WindowListener l = new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    };
    frame.addWindowListener(l);
    frame.pack();
    Dimension screenSize =
                Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    frame.setLocation(screenSize.width/2 - frameSize.width/2,
                  screenSize.height/2 - frameSize.height/2);
    frame.setVisible(true);
  }
}
