// CoVFW.h : Declaration of the CoVFW



#ifndef __OVFW_H_
#define __OVFW_H_

#include "resource.h"       // main symbols

#include "oVFWDriverInfo.h"
#include "CPoVFW.h"

/////////////////////////////////////////////////////////////////////////////
// CoVFW
class ATL_NO_VTABLE CoVFW : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CoVFW, &CLSID_oVFW>,
	public CComControl<CoVFW>,
	public CStockPropImpl<CoVFW, IoVFW, &IID_IoVFW, &LIBID_oVFW>,
	public IProvideClassInfo2Impl<&CLSID_oVFW, &DIID__oVFWEvents, &LIBID_oVFW>,
	public IPersistStreamInitImpl<CoVFW>,
	public IPersistStorageImpl<CoVFW>,
	public IQuickActivateImpl<CoVFW>,
	public IOleControlImpl<CoVFW>,
	public IOleObjectImpl<CoVFW>,
	public IOleInPlaceActiveObjectImpl<CoVFW>,
	public IViewObjectExImpl<CoVFW>,
	public IOleInPlaceObjectWindowlessImpl<CoVFW>,
	public IDataObjectImpl<CoVFW>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CoVFW>,
	public CProxy_oVFWEvents<CoVFW>,
	public ISpecifyPropertyPagesImpl<CoVFW>
{
public:
	CoVFW();
	~CoVFW();

DECLARE_REGISTRY_RESOURCEID(IDR_OVFW)

BEGIN_COM_MAP(CoVFW)
	COM_INTERFACE_ENTRY(IoVFW)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROPERTY_MAP(CoVFW)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()


BEGIN_CONNECTION_POINT_MAP(CoVFW)
    CONNECTION_POINT_ENTRY(DIID__oVFWEvents)
END_CONNECTION_POINT_MAP()


BEGIN_MSG_MAP(CoVFW)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
END_MSG_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = 0;
		return S_OK;
	}

private:
	short w, h;
	bool DetachVFW();
	bool AttachVFW();
	bool StopLiveVideo();
	bool StartLiveVideo();
	bool m_fOverlay;
	short m_previewRate;
	short m_iVideo;
	HWND hWndC;
	CoVFWDriverInfo* pDriverInfo;

// IoVFW
public:
	virtual BOOL IsWindow (HWND hWndC);
	STDMETHOD(EnumDrivers)();
	STDMETHOD(get_CurDriver)(/*[out, retval]*/ IoVFWDriverInfo*  *pVal);
	STDMETHOD(CaptureToBitmapFile)(/*[in]*/BSTR sFileName, /*[out, retval]*/ VARIANT_BOOL * fRC);
	STDMETHOD(CaptureEditCopy)(/*[out, retval]*/VARIANT_BOOL* fRC);
	STDMETHOD(ShowLiveVideo)(/*[in]*/VARIANT_BOOL fShowLiveVideo, /*[out, retval]*/ VARIANT_BOOL* fRC);
	STDMETHOD(get_fOverlay)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_fOverlay)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_PreviewRate)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_PreviewRate)(/*[in]*/ short newVal);
	STDMETHOD(get_iVideo)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_iVideo)(/*[in]*/ short newVal);
	HRESULT OnDraw(ATL_DRAWINFO& di);
};

#endif //__OVFW_H_
