/*
 * $Id: TextBean.java,v 1.3 1998/10/22 23:03:16 begolej Exp $
 *
 * Copyright (c) 1998 James Begole,  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.
 * James Begole SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS
 * SOFTWARE OR ITS DERIVATIVES.
 */

import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;

public synchronized class TextBean extends TextField
  implements Serializable, KeyListener {

  private PropertyChangeSupport changes;

  public TextBean() {
    super(30);
    changes = new PropertyChangeSupport(this);
    addKeyListener(this);
  }

  public void keyTyped(KeyEvent keyEvent) {
  }

  public void keyPressed(KeyEvent keyEvent) {
    if (keyEvent.getKeyChar() == 10) {
      String string = getText();
      changes.firePropertyChange("text", null, string);
    }
  }

  public void keyReleased(KeyEvent keyEvent) {
  }

  public void addPropertyChangeListener(PropertyChangeListener l)
  {
    changes.addPropertyChangeListener(l);
  }

  public void removePropertyChangeListener(PropertyChangeListener l)
  {
    changes.removePropertyChangeListener(l);
  }
}
