// oVFWDriverInfo.cpp : Implementation of CoVFWDriverInfo
#include "stdafx.h"
#include "oVFW.h"
#include "oVFWDriverInfo.h"

/////////////////////////////////////////////////////////////////////////////
// CoVFWDriverInfo

STDMETHODIMP CoVFWDriverInfo::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IoVFWDriverInfo,
	};
	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}


CoVFWDriverInfo::CoVFWDriverInfo()
{
	index= -1;
	fInitCaps= false;
	hWndC= NULL;
}


STDMETHODIMP CoVFWDriverInfo::get_Index(short * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	*pVal= index;
	return S_OK;
}


STDMETHODIMP CoVFWDriverInfo::get_SupportsOverlay(VARIANT_BOOL * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	GetCaps();

	*pVal= (VARIANT_BOOL)caps.fHasOverlay;
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::get_SupportsDlgVideoSource(VARIANT_BOOL * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	GetCaps();

	*pVal= (VARIANT_BOOL)caps.fHasDlgVideoSource;
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::get_SupportsDlgVideoFormat(VARIANT_BOOL * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	GetCaps();

	*pVal= (VARIANT_BOOL)caps.fHasDlgVideoFormat;
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::get_SupportsDlgVideoDisplay(VARIANT_BOOL * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	GetCaps();

	*pVal= (VARIANT_BOOL)caps.fHasDlgVideoDisplay;
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::get_Name(BSTR * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	TCHAR szName[100];
	szName[0]= '\0';
	capDriverGetName(hWndC, szName, sizeof(szName));

	CComBSTR sRet(szName);

	*pVal= sRet.Copy();
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::get_Version(BSTR * pVal)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	TCHAR szVersion[100];
	szVersion[0]= '\0';
	capDriverGetVersion(hWndC, szVersion, sizeof(szVersion));

	CComBSTR sRet(szVersion);

	*pVal= sRet.Copy();
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::DlgVideoDisplay(VARIANT_BOOL * fRC)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	*fRC= (VARIANT_BOOL)capDlgVideoDisplay(hWndC);
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::DlgVideoFormat(VARIANT_BOOL * fRC)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	*fRC= (VARIANT_BOOL)capDlgVideoFormat(hWndC);
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::DlgVideoSource(VARIANT_BOOL * fRC)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	*fRC= (VARIANT_BOOL)capDlgVideoSource(hWndC);
	return S_OK;
}

STDMETHODIMP CoVFWDriverInfo::DlgVideoCompression(VARIANT_BOOL * fRC)
{
	// rougue DriverInfo object.
	if (index< 0 || !IsWindow(hWndC))
		return RogueDriverInfo();

	*fRC= (VARIANT_BOOL)capDlgVideoCompression(hWndC);
	return S_OK;
}

HRESULT CoVFWDriverInfo::RogueDriverInfo()
{
	return Error( _T("oVFWDriverInfo: bad driver information object"), 
					  IID_IoVFWDriverInfo, CUSTOM_CTL_SCODE(1009));
}
