// oVFWDriverInfo.h : Declaration of the CoVFWDriverInfo

#ifndef __OVFWDRIVERINFO_H_
#define __OVFWDRIVERINFO_H_

#include <vfw.h>
#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CoVFWDriverInfo
class ATL_NO_VTABLE CoVFWDriverInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CoVFWDriverInfo, &CLSID_oVFWDriverInfo>,
	public ISupportErrorInfo,
	public IDispatchImpl<IoVFWDriverInfo, &IID_IoVFWDriverInfo, &LIBID_oVFW>
{
public:
	CoVFWDriverInfo();

DECLARE_REGISTRY_RESOURCEID(IDR_OVFWDRIVERINFO)

BEGIN_COM_MAP(CoVFWDriverInfo)
	COM_INTERFACE_ENTRY(IoVFWDriverInfo)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IoVFWDriverInfo
public:
	STDMETHOD(DlgVideoCompression)(/*[out, retval]*/VARIANT_BOOL* fRC);
	STDMETHOD(DlgVideoSource)(/*[out, retval]*/VARIANT_BOOL* fRC);
	STDMETHOD(DlgVideoFormat)(/*[out, retval]*/VARIANT_BOOL* fRC);
	STDMETHOD(DlgVideoDisplay)(/*[out, retval]*/ VARIANT_BOOL*fRC);
	STDMETHOD(get_Version)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_Name)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_SupportsDlgVideoDisplay)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(get_SupportsDlgVideoFormat)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(get_SupportsDlgVideoSource)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(get_SupportsOverlay)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(get_Index)(/*[out, retval]*/ short *pVal);

public:
	short index;
	HWND hWndC;

private:
	HRESULT RogueDriverInfo();
	bool fInitCaps;
	CAPDRIVERCAPS caps;

	// inline for speed.
	void GetCaps() {
		if (!fInitCaps) {
			fInitCaps= true;
			capDriverGetCaps(hWndC, &caps, sizeof(caps));
		}
	};
};

#endif //__OVFWDRIVERINFO_H_
